/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
***
***  Contact author(s): abk@cs.ucla.edu, imarkov@cs.ucla.edu
***  Affiliation:   UCLA, Computer Science Department,
***                 Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/




//created by Andrew Caldwell and Igor Markov on 05/24/98

#ifndef __SV_GAIN_ELEMENT_H__
#define __SV_GAIN_ELEMENT_H__

#include "GainContainers/genericGainElmt.h"

class SVGainElement : public GenericGainElement
{
  public:

    SVGainElement()
	: GenericGainElement()
	{}

    virtual 	 ~SVGainElement() {}
    int getGain() const 	{ return _gain; }
    int getRealGain() const 	{ return _gain + _gainOffset;}
    
    virtual void print(ostream& os)
    {    os<<(*this); }

    friend ostream& operator<<(ostream&, const SVGainElement&);
};

inline ostream& operator<<(ostream& os, const SVGainElement& elmt)
{ os<<"["<<elmt._gain<<"+"<<elmt._gainOffset<<"]"; return os; }

#endif

