/**************************************************************************
***
***    Copyright (c) 1995-2000 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

#include "ABKCommon/abkcommon.h"
#include "DB/DB.h"
#include "RBPlaceFromDB/RBPlaceFromDB.h"

// Test for aux file reader

int main(int argc, char *argv[])
{
  StringParam auxFileName("f",argc,argv);
  abkfatal(auxFileName.found(),"Usage: prog -f filename.aux");
  DB db(auxFileName);
  RBPlacement::Parameters params;
  RBPlaceFromDB rbplace(db,params);

  char before[]="rbps";
  char *placeFileName = new char[strlen(before)+strlen(auxFileName)
                                 +1];
  strcpy(placeFileName,before);
  strcat(placeFileName,auxFileName);

  rbplace.saveAsNetDAre(placeFileName);

  char simplelc[]=".simplelc";
  char *constrFileName=new char[strlen(placeFileName)+strlen(simplelc)+1];
  strcpy(constrFileName,placeFileName);
  strcat(constrFileName,simplelc);

  rbplace.saveAsSpatialConstraints(constrFileName);

  delete [] placeFileName;
  delete [] constrFileName;

  return 0;
}

