/**************************************************************************
***
***    Copyright (c) 1995-1998 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this package may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

// Created by Igor Markov

#ifndef _1BAL_CHK_H_
#define _1BAL_CHK_H_

#include "partProb.h"
#include "partitionIds.h"

class SBGWeightRand;
class SBGWeightRandDutt;
class SBGWeightRandLC;
class SBGWeightRandLCwBFS;

typedef SBGWeightRandDutt   SingleBalanceGenerator;
//typedef SBGWeightRandLCwBFS SingleBalanceGenerator2way;

class SBGWeightRand
{
    const PartitioningProblem& 	_problem;
    RandomRawUnsigned	   	_ru;

  public:

    SBGWeightRand( const PartitioningProblem& problem)
	:_problem(problem)
	{}

    vector<double> generateSoln(Partitioning& curPart );

};

class SBGWeightRandDutt
{
    const PartitioningProblem& 	_problem;
    RandomRawUnsigned	   	_ru;

  public:

    SBGWeightRandDutt( const PartitioningProblem& problem)
	:_problem(problem)
	{}

    vector<double> generateSoln(Partitioning& curPart );

};

class SBGWeightRandLC
{
    const PartitioningProblem& 	_problem;
    RandomRawUnsigned	   	_ru;

  public:

    SBGWeightRandLC( const PartitioningProblem& problem)
	:_problem(problem)
	{}

    vector<double> generateSoln(Partitioning& curPart );

};

class SBGWeightRandLCwBFS
{
    const PartitioningProblem& 	_problem;
    RandomRawUnsigned	   	_ru;

  public:

    SBGWeightRandLCwBFS( const PartitioningProblem& problem)
	:_problem(problem)
	{}

    vector<double> generateSoln(Partitioning& curPart );

};

#endif
